/*****************************************************************************
* Copyright (c) Future Technology Devices International 2014
* propriety of Future Technology devices International.
*
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by FTDI. 
* FTDI accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file                           Receiver_Enhanced_HW_Flow_Ctl.ino
* @brief                          Sketch to demonstrate enhanced hardware flow control functionality for VI800A-232U add-on module.
								  Tested platform version: Arduino 1.0.4 and later
* @version                        1.0.0
* @date                           2014/10/01
*
*/


/* Arduino standard includes */
#include "SPI.h"
#include "Wire.h"


#include "FT_VI800A_232U.h"

FT_VI800A VI800A;

void setup()
{
	/* Initialize serial print related functionality */
	Serial.begin(9600);
    Serial.println("\n\r\n\r-----------Receiver_Enhanced_HW_Flow_Ctl.ino--------------");
	
	VI800A.Init(FT_232U_CS,9600,FT_VI800A_No_Parity, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
	VI800A.SetFlowControl(FT_VI800A_HW_Flow, FT_VI800A_Use_FCR_RX_Trigger, FT_VI800A_RX_Sixteen_Characters);
}

char incommingData;

void loop()
{
	if(VI800A.GetReceiveFIFOFillLevel()){
			incommingData = VI800A.Read();
			Serial.print(incommingData);
			Serial.print(" ");
			Serial.print("FIFO fill level: ");
			Serial.println(VI800A.GetReceiveFIFOFillLevel());
			delay(100);
	}	
}
















