/*****************************************************************************
* Copyright (c) Future Technology Devices International 2014
* propriety of Future Technology devices International.
*
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by FTDI. 
* FTDI accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file                           Receiver_Enhanced_SW_Flow_Ctl_2.ino
* @brief                          Sketch to demonstrate enhanced software flow control functionality for VI800A-232U add-on module.
								  Tested platform version: Arduino 1.0.4 and later
* @version                        1.0.0
* @date                           2014/10/01
*
*/


/* Arduino standard includes */
#include "SPI.h"
#include "Wire.h"

#include "FT_VI800A_232U.h"

FT_VI800A VI800A;


void setup()
{
	/* Initialize serial print related functionality */
	Serial.begin(9600);
    Serial.println("\n\r\n\r-----------Receiver_Enhanced_SW_Flow_Ctl_2.ino--------------");
	
	/*Use default values of 9600 baud rate, no parity bit, 1 stop bit, and 8 data bits*/ 
	VI800A.Init(FT_232U_CS);
	
	//transmit xon1 and xon2 for signaling more data can be accepted, and xoff1 and xoff2 for stop data transmission. 0x01 as the xon special character and 0x02 as the xoff special character.  Use FCR trigger level with the halt level of 60. 

	VI800A.SetFlowControl(FT_VI800A_SW_Flow,FT_VI800A_TX_XON1_XON2_XOFF1_XOFF2,48,48,49,49, FT_VI800A_Use_FCR_RX_Trigger, FT_VI800A_RX_Sixty_Characters);
}

char command, incomingData, g_var='A';

void loop()
{
	if (Serial.available() > 0){
		command = Serial.read();
		if(command == 'l'){ //send line break condition
			VI800A.StartTransmitLineBreak();
			delay(5);
			VI800A.StopTransmitLineBreak();
		}
		else{
			VI800A.Write(command);
			Serial.print("Sent: ");
			Serial.println(command);
		}
	}
	
	if(VI800A.isDataInReceiver())
	{
		incomingData = VI800A.Read();
		if(g_var != incomingData)
		{
			Serial.print(g_var);
			Serial.print(' ');
			Serial.print(incomingData);
			Serial.print(' ');
		}
			delay(50);
			g_var++;
			//Serial.print("FIFO fill level: ");  //FIFO fill level
			Serial.println(VI800A.GetReceiveFIFOFillLevel());
			if(g_var > 'Z')
			{
				g_var = 'A';
			}
	}
	
}





 
























